{$D+}
{$L+}
unit Lerodbu1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, ExtCtrls, StdCtrls, Buttons, Rdonly;

type
  TRODBRead = class(TForm)
    testrodb: TRReadOnlyDB;
    emppornome: TRReadOnlyIndex;
    emppormatricula: TRReadOnlyIndex;
    empporsalario: TRReadOnlyIndex;
    emppordepto: TRReadOnlyIndex;
    deptoporcod: TRReadOnlyIndex;
    crodb_mmn: TMainMenu;
    mmn_arquivo: TMenuItem;
    mmn_opendb: TMenuItem;
    mmn_closedb: TMenuItem;
    mmn_div1: TMenuItem;
    mmn_open1index: TMenuItem;
    mmn_div2: TMenuItem;
    mmn_sair: TMenuItem;
    mmn_consulta: TMenuItem;
    mmn_ajuda: TMenuItem;
    mmn_sobre: TMenuItem;
    mmn_consdep: TMenuItem;
    mmn_consdepcod: TMenuItem;
    mmn_consemp: TMenuItem;
    mmn_consempnome: TMenuItem;
    mmn_consempmat: TMenuItem;
    mmn_consempsal: TMenuItem;
    mmn_consempcod: TMenuItem;
    pnl_geral: TPanel;
    lab_rodb: TLabel;
    indexindex: TRReadOnlyIndex;
    mmn_openempsal: TMenuItem;
    mmn_openempmat: TMenuItem;
    mmn_openempcod: TMenuItem;
    mmn_opendepcod: TMenuItem;
    mmn_div3: TMenuItem;
    mmn_openinxinx: TMenuItem;
    mmn_close1index: TMenuItem;
    mmn_closeinxinx: TMenuItem;
    mmn_div6: TMenuItem;
    mmn_closedepcod: TMenuItem;
    mmn_closeempcod: TMenuItem;
    mmn_closeempmat: TMenuItem;
    mmn_closeempsal: TMenuItem;
    mmn_consinxinx: TMenuItem;
    mmn_openallinxes: TMenuItem;
    mmn_closeallinxes: TMenuItem;
    mmn_openempnome: TMenuItem;
    mmn_closeempnome: TMenuItem;
    lab_titcons: TLabel;
    edt_busca: TEdit;
    btn_busca: TBitBtn;
    mem_reg: TMemo;
    btn_prim: TButton;
    btn_prox: TButton;
    btn_ant: TButton;
    btn_ult: TButton;
    btn_sair: TBitBtn;
    procedure mmn_opendbClick(Sender: TObject);
    procedure mmn_closedbClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mmn_sairClick(Sender: TObject);
    procedure mmn_openempsalClick(Sender: TObject);
    procedure mmn_closeempsalClick(Sender: TObject);
    procedure mmn_closeempmatClick(Sender: TObject);
    procedure mmn_closeempcodClick(Sender: TObject);
    procedure mmn_closedepcodClick(Sender: TObject);
    procedure mmn_closeinxinxClick(Sender: TObject);
    procedure mmn_closeallinxesClick(Sender: TObject);
    procedure mmn_openempmatClick(Sender: TObject);
    procedure mmn_openempcodClick(Sender: TObject);
    procedure mmn_opendepcodClick(Sender: TObject);
    procedure mmn_openinxinxClick(Sender: TObject);
    procedure mmn_openempnomeClick(Sender: TObject);
    procedure mmn_closeempnomeClick(Sender: TObject);
    procedure mmn_openallinxesClick(Sender: TObject);
    procedure mmn_consempnomeClick(Sender: TObject);
    procedure btn_sairClick(Sender: TObject);
    procedure mmn_consempmatClick(Sender: TObject);
    procedure mmn_consempsalClick(Sender: TObject);
    procedure mmn_consempcodClick(Sender: TObject);
    procedure mmn_consdepcodClick(Sender: TObject);
    procedure mmn_consinxinxClick(Sender: TObject);
    procedure btn_primClick(Sender: TObject);
    procedure btn_proxClick(Sender: TObject);
    procedure btn_antClick(Sender: TObject);
    procedure btn_ultClick(Sender: TObject);
    procedure btn_buscaClick(Sender: TObject);
    procedure edt_buscaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edt_buscaChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
    RODBRead: TRODBRead;

function StrToPChar (S: string): PChar;

implementation

{$R *.DFM}

uses
    u_ordem;

type
    AuxArr   = array [1..100] of char;
    Str60    = string [60];
    Str120   = string [120];
    ChArr4   = array [1..4] of char; { para longint }
    ChArr6   = array [1..6] of char; { para real }
    ChArr10  = array [1..10] of char;
    ChArr61  = array [1..61] of char;
    KEProc   = procedure (var Key, Val);
    FProc    = procedure (var Buff; Full: boolean; RecNo: longint;
                                                                Exact: boolean);

    ArrStr = record
        Len: byte;
        Cnt: array [0..254] of char;
        end;
    Arr10Str = record
        Len: byte;
        Cnt10: array [1..10] of char;
        Cnt245: array [11..255] of char;
        end;

    TEmpregado = record
        Nome: Str60;
        Matricula: longint;
        Salario: real;
        Depto: ChArr10;
        end;
    TDepartamento = record
        Codigo: ChArr10;
        Nome: Str120;
        end;
    TIndice = record
        Nome: Str10;
        ChaveTam: word;
        QtRegs: longint;
        InicPosicao: longint;
        end;

var
    Empregado: TEmpregado;
    Departamento: TDepartamento;
    ActiveInx: TRReadOnlyIndex;
    ActiveEval: KEProc;
    ActiveFProc: FProc;
    ActiveKey: pointer;
    ActiveBuff: pointer;
    ActiveBufLen: word;
    Indice: TIndice;
    PChars: string;
    BancoAberto: boolean;
    EPNAberto: boolean;
    EPMAberto: boolean;
    EPSAberto: boolean;
    EPCAberto: boolean;
    DPCAberto: boolean;
    IxIxAberto: boolean;

    { Keys }
    EmpregadoNome: Str60;
    EmpregadoMatricula: longint;
    EmpregadoSalario: real;
    EmpregadoDepto: ChArr10;
    DepartamentoCodigo: ChArr10;
    IndiceNumero : longint;

function StrToPChar (S: string): pchar;
{        -----------------------------}
begin
PChars := S + #0;
Result := @ArrStr (PChars).Cnt;
end; { StrToPChar }

function Exato (Found: boolean): string;
{        ------------------------------}
begin
if Found then
    Result := 'Exato'
else
    Result := 'Aproximado';
end; { Exato }

function ErrorMessage (ErrorNumber: integer): string;
{        -------------------------------------------

Transliterao dos erros
}
begin
case ErrorNumber of
esNoError:
    Result := 'Nenhum Erro';
esDBNotOpen:
    Result := 'O Banco de Dados est Fechado';
esDBNotClosed:
    Result := 'O Banco de Dados est Aberto';
esFileAccessError:
    Result := 'Erro de Leitura ou Gravao sobre o Banco de Dados';
esFileOpenError:
    Result := 'Erro durante a abertura do arquivo do Banco de Dados';
esCorruptDataFile:
    Result := 'Arquivo fsico do Banco corrompido';
esNotAssigned:
    Result := 'O ndice precisa ter um nome';
esBadKeyValue:
    Result := 'Valor incorreto para a Chave';
esCreateError:
    Result := 'Erro de Leitura ou Gravao durante a criao do Banco de Dados';
esKeysNotSameSize:
    Result := 'Uma ou ambas as Chaves no so do Tamanho definido';
esBadIndexName:
    Result := 'Nome do ndice no reconhecido ou invlido';
esSameNameIndex:
    Result := 'Este ndice j existe';
esShortBuffer:
    Result := 'Advertncia apenas: O Buffer  menor que o registro!';
esNotConnected:
    Result := 'O ndice est Fechado';
esAlreadyConnected:
    Result := 'O ndice est Aberto';
esOutOfMemory:
    Result := 'Memria Insuficiente';
esMaxIndexesExceeded:
    Result := 'ndices demais (Mximo = 16384)';
esInvalidKeyLength:
    Result := 'Comprimento invlido para a Chave do ndice';
esNoCurrentRecord:
    Result := 'No h registro corrente';
esNotFound:
    Result := 'No foi encontrado nenhum registro';
esInvalidRecLength:
    Result := 'Tamanho invlido para o registro';
esNonRegistered:
    Result := 'A Verso no registrada exige o Delphi';
else
    Result := 'Cdigo de erro no reconhecido: ' + IntToStr (ErrorNumber)
    end;
end; { ErrorMessage }

{$F+} { Isto  necessrio }

{ Funes de avaliao das chaves dos diversos ndices }

procedure EmpNomeEval (var Key, Val);
begin
ChArr61(Val) := ChArr61 (Key);
end;

procedure EmpMatEval (var Key, Val);
var
    Value: longint;
begin
Value := StrToInt (string (Key));
ChArr4 (Val) := ChArr4 (Value);
end;

procedure EmpSalEval (var Key, Val);
var
    Value: real;
begin
Value := StrToFloat (string (Key));
ChArr6 (Val) := ChArr6 (Value);
end;

procedure EmpCodEval (var Key, Val);
begin
while ArrStr (Key).Len < 10 do
    String (Key) := String (Key) + ' ';
ChArr10 (Val) := ChArr10 (Arr10Str (Key).Cnt10);
end;

procedure DepCodEval (var Key, Val);
begin
while ArrStr (Key).Len < 10 do
    String (Key) := String (Key) + ' ';
ChArr10 (Val) := ChArr10 (Arr10Str (Key).Cnt10);
end;

procedure InxNumEval (var Key, Val);
var
    Value: longint;
begin
Value := StrToInt (string (Key));
ChArr4 (Val) := ChArr4 (Value);
end;

{ Formatao dos registros vindos do Banco de Dados }

procedure EmpFormat (var Buff; Full: boolean; RecNo: longint; Exact: boolean);
begin
with rodbRead, mem_reg, TEmpregado (Buff) do
    if Full then
        begin
        lines.add ('----> Registro # ' + IntToStr (RecNo) + ' (' +
                                                     Exato (Exact) + ') <----');
        lines.add ('Nome:         ' + Nome);
        lines.add ('Matrcula:    ' + IntToStr (Matricula));
        lines.add ('Salrio:      ' + FormatFloat (',######0.00', Salario));
        lines.add ('Departamento: ' + Depto);
        end
    else
        lines.add ('##### Registro No Encontrado #####');
end;

procedure DeptoFormat (var Buff; Full: boolean; RecNo: longint; Exact: boolean);
begin
with rodbRead, mem_reg, TDEpartamento (Buff) do
    if Full then
        begin
        lines.add ('----> Registro # ' + IntToStr (RecNo) + ' (' +
                                                     Exato (Exact) + ') <----');
        lines.add ('Cdigo: ' + Codigo);
        lines.add ('Nome:   ' + Nome);
        end
    else
        lines.add ('##### Registro No Encontrado #####');
end;

procedure IndexFormat (var Buff; Full: boolean; RecNo: longint; Exact: boolean);
begin
with rodbRead, mem_reg, TIndice (Buff) do
    if Full then
        begin
        lines.add ('----> Registro # ' + IntToStr (RecNo) + ' (' +
                                                     Exato (Exact) + ') <----');
        lines.add ('Nome do ndice:             ' + Nome);
        lines.add ('Comprimento da Chave:       ' + IntToStr (ChaveTam));
        lines.add ('Quantidade de Registros:    ' + IntToStr (QtRegs));
        lines.add ('Posico Inicial no Arquivo: ' + IntToStr (InicPosicao));
        end
    else
        lines.add ('##### Registro No Encontrado #####');
end;
{$F-}

procedure IniciaConsulta (Inx: TRReadOnlyIndex; Tit: string; KEval: KEProc;
                          Format: FProc; KeyPtr, BufPtr: pointer; BufLen: word);
begin
if not BancoAberto then
    begin
    Application.MessageBox ('O Banco de Dados est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
if not Inx.Connected then
    begin
    Application.MessageBox ('O ndice est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
with rodbRead do
    begin
    mmn_consulta.enabled := false;
    mmn_arquivo.enabled  := false;
    lab_titcons.caption  := tit;
    ActiveInx            := Inx;
    ActiveEval           := KEval;
    ActiveFProc          := Format;
    ActiveKey            := KeyPtr;
    ActiveBuff           := BufPtr;
    ActiveBufLen         := BufLen;
    edt_busca.text       := '';
    mem_reg.clear;
    lab_titcons.visible  := true;
    edt_busca.visible    := true;
    btn_busca.visible    := true;
    mem_reg.visible      := true;
    btn_prim.visible     := true;
    btn_prox.visible     := true;
    btn_ant.visible      := true;
    btn_ult.visible      := true;
    btn_sair.visible     := true;
    end;
end;

procedure TRODBRead.mmn_opendbClick(Sender: TObject);
var
    ErrCode: integer;
begin
if BancoAberto then
    begin
    Application.MessageBox ('O Banco de Dados est Aberto', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
testrodb.DBOpen;
ErrCode := TestroDB.DBErrorCode;
if ErrCode <> 0 then
    Application.MessageBox (StrToPChar ('Erro na Abertura do Banco: ' +
                ErrorMessage (ErrCode)), 'Ateno!', mb_Ok + mb_IconExclamation)
else
    begin
    BancoAberto := true;
    mmn_openallinxesClick (Sender);
    end;
end;

procedure TRODBRead.mmn_closedbClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not BancoAberto then
    begin
    Application.MessageBox ('O Banco de Dados est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
mmn_closeallinxesClick (Sender);
testrodb.DBClose;
Errcode := Testrodb.DBErrorCode;
if TestroDB.DBErrorCode <> 0 then
    Application.MessageBox (StrToPChar ('Erro no Fechamento do Banco de ' +
        'Dados: ' + ErrorMessage (ErrCode)),
                                         'Ateno!', mb_Ok + mb_iconexclamation)
else
    BancoAberto := false;
end;

procedure TRODBRead.FormCreate(Sender: TObject);
begin
BancoAberto := false;
EPNAberto   := false;
EPSAberto   := false;
EPMAberto   := false;
EPCAberto   := false;
DPCAberto   := false;
IxIxAberto  := false;
end;

procedure TRODBRead.mmn_sairClick(Sender: TObject);
begin
if BancoAberto then
    mmn_closedbclick (Sender);
close;
end;

procedure TRODBRead.mmn_openempsalClick(Sender: TObject);
var
    ErrCode: integer;
begin
if EPSAberto then
    begin
    Application.MessageBox ('O ndice Empregado por Salrio j est Aberto',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
testrodb.OpenIndex (empporsalario, @RealCompare);
ErrCode := TestroDB.DBErrorCode;
if ErrCode <> 0 then
    Application.MessageBox (StrToPChar ('Erro na Abertura do ndice ' +
        'Empregado por Salrio: ' + ErrorMessage (ErrCode)),
                                         'Ateno!', mb_Ok + mb_iconexclamation)
else
    EPSAberto := true;
end;

procedure TRODBRead.mmn_closeempsalClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not EPSAberto then
    begin
    Application.MessageBox ('O ndice Empregado por Salrio j est Fechado',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
empporsalario.IndexClose;
ErrCode := empporsalario.IndexErrorCode;
if Errcode <> 0 then
    begin
    Application.MessageBox (StrToPChar ('Erro no Fechamento do ndice ' +
            'Empregado por Salrio: ' + ErrorMessage (ErrCode)),
                                        'Ateno!', mb_Ok + mb_iconexclamation);
    Exit;
    end
else
    EPSAberto := false;
end;

procedure TRODBRead.mmn_closeempmatClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not EPMAberto then
    begin
    Application.MessageBox ('O ndice Empregado por Matrcula j est Fechado',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
emppormatricula.IndexClose;
ErrCode := emppormatricula.IndexErrorCode;
if Errcode <> 0 then
    begin
    Application.MessageBox (StrToPChar ('Erro no Fechamento do ndice ' +
            'Empregado por Matrcula: ' + ErrorMessage (ErrCode)),
                                        'Ateno!', mb_Ok + mb_iconexclamation);
    Exit;
    end
else
    EPMAberto := false;
end;

procedure TRODBRead.mmn_closeempcodClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not EPCAberto then
    begin
    Application.MessageBox ('O ndice Empregado por Cdigo do Departamento ' +
                      'j est Fechado', 'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
emppordepto.IndexClose;
ErrCode := emppordepto.IndexErrorCode;
if Errcode <> 0 then
    begin
    Application.MessageBox (StrToPChar ('Erro no Fechamento do ndice ' +
            'Empregado por Cdigo de Departamento: ' + ErrorMessage (ErrCode)),
                                        'Ateno!', mb_Ok + mb_iconexclamation);
    Exit;
    end
else
    EPCAberto := false;
end;

procedure TRODBRead.mmn_closedepcodClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not DPCAberto then
    begin
    Application.MessageBox ('O ndice Departamento por Cdigo j est Fechado',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
deptoporcod.IndexClose;
ErrCode := deptoporcod.IndexErrorCode;
if Errcode <> 0 then
    begin
    Application.MessageBox (StrToPChar ('Erro no Fechamento do ndice ' +
            'Departamento por Cdigo: ' + ErrorMessage (ErrCode)),
                                        'Ateno!', mb_Ok + mb_iconexclamation);
    Exit;
    end
else
    DPCAberto := false;
end;

procedure TRODBRead.mmn_closeinxinxClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not IxIxAberto then
    begin
    Application.MessageBox ('O ndice de ndices j est Fechado',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
indexindex.IndexClose;
ErrCode := indexIndex.IndexErrorCode;
if Errcode <> 0 then
    begin
    Application.MessageBox (StrToPChar ('Erro no Fechamento do ndice ' +
            'de ndices: ' + ErrorMessage (ErrCode)),
                                        'Ateno!', mb_Ok + mb_iconexclamation);
    Exit;
    end
else
    IxIxAberto:= false;
end;

procedure TRODBRead.mmn_closeallinxesClick(Sender: TObject);
begin
if EPNAberto then
    mmn_closeempnomeClick (Sender);
if EPMAberto then
    mmn_closeempmatClick  (Sender);
if EPSAberto then
    mmn_closeempsalClick  (Sender);
if EPCAberto then
    mmn_closeempcodClick  (Sender);
if DPCAberto then
    mmn_closedepcodClick  (Sender);
if IxIxAberto then
    mmn_closeInxInxClick  (Sender);
end;

procedure TRODBRead.mmn_openempmatClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not BancoAberto then
    begin
    Application.MessageBox ('O Banco est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
if EPMAberto then
    begin
    Application.MessageBox ('ndice Empregado por Matrcula j Aberto',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
testrodb.OpenIndex (emppormatricula, @LongintCompare);
ErrCode := TestroDB.DBErrorCode;
if ErrCode <> 0 then
    Application.MessageBox (StrToPChar ('Erro na Abertura do ndice ' +
        'Empregado por Matrcula: ' + ErrorMessage (ErrCode)),
                                         'Ateno!', mb_Ok + mb_iconexclamation)
else
    EPMAberto := true;
end;

procedure TRODBRead.mmn_openempcodClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not BancoAberto then
    begin
    Application.MessageBox ('O Banco est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
if EPCAberto then
    begin
    Application.MessageBox ('ndice Empregado por Cdigo do Departamento ' +
                            'j Aberto', 'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
testrodb.OpenIndex (emppordepto, nil);
ErrCode := TestroDB.DBErrorCode;
if TestroDB.DBErrorCode <> 0 then
    Application.MessageBox (StrToPChar ('Erro na Abertura do ndice ' +
        'Empregado por Cdigo do Departamento: ' + ErrorMessage (ErrCode)),
                                         'Ateno!', mb_Ok + mb_iconexclamation)
else
    EPCAberto := true;
end;

procedure TRODBRead.mmn_opendepcodClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not BancoAberto then
    begin
    Application.MessageBox ('O Banco est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
if DPCAberto then
    begin
    Application.MessageBox ('ndice Departamento por Cdigo j Aberto',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
testrodb.OpenIndex (deptoporcod, @ChArr10Compare);
ErrCode := TestroDB.DBErrorCode;
if TestroDB.DBErrorCode <> 0 then
    Application.MessageBox (StrToPChar ('Erro na Abertura do ndice ' +
        'Departamento por Cdigo: ' + ErrorMessage (ErrCode)),
                                         'Ateno!', mb_Ok + mb_iconexclamation)
else
    DPCAberto := true;
end;

procedure TRODBRead.mmn_openinxinxClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not BancoAberto then
    begin
    Application.MessageBox ('O Banco est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
if IxIxAberto then
    begin
    Application.MessageBox ('ndice de ndices j Aberto',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
testrodb.OpenIndex (indexindex, nil);
ErrCode := TestroDB.DBErrorCode;
if TestroDB.DBErrorCode <> 0 then
    Application.MessageBox (StrToPChar ('Erro na Abertura do ndice ' +
        'de ndices: ' + ErrorMessage (ErrCode)),
                                         'Ateno!', mb_Ok + mb_iconexclamation)
else
    IxIxAberto := true;
end;

procedure TRODBRead.mmn_openempnomeClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not BancoAberto then
    begin
    Application.MessageBox ('O Banco est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
if EPNAberto then
    begin
    Application.MessageBox ('ndice Empregado por Nome j Aberto',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
testrodb.OpenIndex (emppornome, @StringCompare);
ErrCode := TestroDB.DBErrorCode;
if TestroDB.DBErrorCode <> 0 then
    Application.MessageBox (StrToPChar ('Erro na Abertura do ndice ' +
        'Empregado por Nome: ' + ErrorMessage (ErrCode)),
                                         'Ateno!', mb_Ok + mb_iconexclamation)
else
    EPNAberto := true;
end;

procedure TRODBRead.mmn_closeempnomeClick(Sender: TObject);
var
    ErrCode: integer;
begin
if not EPNAberto then
    begin
    Application.MessageBox ('O ndice Empregado por Nome j est Fechado',
                                         'Ateno', mb_ok + mb_iconexclamation);
    Exit;
    end;
emppornome.IndexClose;
ErrCode := emppornome.IndexErrorCode;
if Errcode <> 0 then
    begin
    Application.MessageBox (StrToPChar ('Erro no Fechamento do ndice ' +
            'Empregado por Nome: ' + ErrorMessage (ErrCode)),
                                        'Ateno!', mb_Ok + mb_iconexclamation);
    Exit;
    end
else
    EPNAberto := false;
end;

procedure TRODBRead.mmn_openallinxesClick(Sender: TObject);
begin
if not BancoAberto then
    begin
    Application.MessageBox ('O Banco de Dados est Fechado', 'Ateno',
                                                    mb_ok + mb_iconexclamation);
    Exit;
    end;
if not EPNAberto then
    mmn_openempnomeClick (Sender);
if not EPMAberto then
    mmn_openempmatClick  (Sender);
if not EPSAberto then
    mmn_openempsalClick  (Sender);
if not EPCAberto then
    mmn_openempcodClick  (Sender);
if not DPCAberto then
    mmn_opendepcodClick  (Sender);
if not IxIxAberto then
    mmn_openInxInxClick  (Sender);
end;

procedure TRODBRead.mmn_consempnomeClick(Sender: TObject);
begin
IniciaConsulta (emppornome, 'Consulta Empregado por Nome', EmpNomeEval,
                    EmpFormat, @EmpregadoNome, @Empregado, SizeOf (TEmpregado));
end;

procedure TRODBRead.btn_sairClick(Sender: TObject);
begin
with rodbRead do
    begin
    lab_titcons.visible  := false;
    edt_busca.visible    := false;
    btn_busca.visible    := false;
    mem_reg.visible      := false;
    btn_prim.visible     := false;
    btn_prox.visible     := false;
    btn_ant.visible      := false;
    btn_ult.visible      := false;
    btn_sair.visible     := false;
    mmn_consulta.enabled := true;
    mmn_arquivo.enabled  := true;
    end;
end;

procedure TRODBRead.mmn_consempmatClick(Sender: TObject);
begin
IniciaConsulta (emppormatricula, 'Consulta Empregado por Matrcula', EmpMatEval,
               EmpFormat, @EmpregadoMatricula, @Empregado, SizeOf (TEmpregado));
end;

procedure TRODBRead.mmn_consempsalClick(Sender: TObject);
begin
IniciaConsulta (empporsalario, 'Consulta Empregado por Salrio (Decrescente)',
     EmpSalEval, EmpFormat, @EmpregadoSalario, @Empregado, SizeOf (TEmpregado));
end;

procedure TRODBRead.mmn_consempcodClick(Sender: TObject);
begin
IniciaConsulta (emppordepto, 'Consulta Empregado por Cdigo de Departamento',
        EmpCodEval, EmpFormat, @EmpregadoDepto, @Empregado, SizeOf (Empregado));
end;

procedure TRODBRead.mmn_consdepcodClick(Sender: TObject);
begin
IniciaConsulta (deptoporcod, 'Consulta Departamento por Cdigo', DepCodEval,
        DeptoFormat, @DepartamentoCodigo, @Departamento, SizeOf (Departamento));
end;

procedure TRODBRead.mmn_consinxinxClick(Sender: TObject);
begin
IniciaConsulta (indexindex, 'Consulta a relao de ndices', InxNumEval,
                         IndexFormat, @IndiceNumero, @Indice, SizeOf (TIndice));
end;

procedure TRODBRead.btn_primClick(Sender: TObject);
var
    ErrCode: integer;
    RetBufLen: word;
begin
edt_busca.text := '';
ActiveInx.GoFirst (ActiveBuff^, ActiveBufLen, RetBufLen);
ErrCode := ActiveInx.IndexErrorCode;
if ErrCode = 0 then
    ActiveFProc (ActiveBuff^, true, ActiveInx.EntryNumber, ActiveInx.Match)
else
if ErrCode = esNotFound then
    ActiveFProc (ActiveBuff^, false, 0, false)
else
    Application.MessageBox (StrToPChar  ('Erro na Busca: ' +
               ErrorMessage (ErrCode)), 'Ateno!', mb_Ok + mb_IconExclamation);
end;

procedure TRODBRead.btn_proxClick(Sender: TObject);
var
    ErrCode: integer;
    RetBufLen: word;
begin
edt_busca.text := '';
ActiveInx.GoNext (ActiveBuff^, ActiveBufLen, RetBufLen);
ErrCode := ActiveInx.IndexErrorCode;
if ErrCode = 0 then
    ActiveFProc (ActiveBuff^, true, ActiveInx.EntryNumber, ActiveInx.Match)
else
if ErrCode = esNotFound then
    ActiveFProc (ActiveBuff^, false, 0, false)
else
    Application.MessageBox (StrToPChar  ('Erro na Busca: ' +
               ErrorMessage (ErrCode)), 'Ateno!', mb_Ok + mb_IconExclamation);
end;

procedure TRODBRead.btn_antClick(Sender: TObject);
var
    ErrCode: integer;
    RetBufLen: word;
begin
edt_busca.text := '';
ActiveInx.GoPrev (ActiveBuff^, ActiveBufLen, RetBufLen);
ErrCode := ActiveInx.IndexErrorCode;
if ErrCode = 0 then
    ActiveFProc (ActiveBuff^, true, ActiveInx.EntryNumber, ActiveInx.Match)
else
if ErrCode = esNotFound then
    ActiveFProc (ActiveBuff^, false, 0, false)
else
    Application.MessageBox (StrToPChar  ('Erro na Busca: ' +
               ErrorMessage (ErrCode)), 'Ateno!', mb_Ok + mb_IconExclamation);
end;

procedure TRODBRead.btn_ultClick(Sender: TObject);
var
    ErrCode: integer;
    RetBufLen: word;
begin
edt_busca.text := '';
ActiveInx.GoLast (ActiveBuff^, ActiveBufLen, RetBufLen);
ErrCode := ActiveInx.IndexErrorCode;
if ErrCode = 0 then
    ActiveFProc (ActiveBuff^, true, ActiveInx.EntryNumber, ActiveInx.Match)
else
if ErrCode = esNotFound then
    ActiveFProc (ActiveBuff^, false, 0, false)
else
    Application.MessageBox (StrToPChar  ('Erro na Busca: ' +
               ErrorMessage (ErrCode)), 'Ateno!', mb_Ok + mb_IconExclamation);
end;

procedure TRODBRead.btn_buscaClick(Sender: TObject);
var
    ErrCode: integer;
    Value: string;
    RetBufLen: word;
begin
Value := edt_busca.text;
try
    ActiveEval (Value, ActiveKey^);
except
    on EConvertError do
        Application.MessageBox ('Erro de Converso do Valor para Busca',
                                         'Ateno', mb_ok + mb_iconexclamation);
    end;
ActiveInx.Find (ActiveKey^, ActiveBuff^, ActiveBufLen, RetBufLen);
ErrCode := ActiveInx.IndexErrorCode;
if ErrCode = 0 then
    ActiveFProc (ActiveBuff^, true, ActiveInx.EntryNumber, ActiveInx.Match)
else
if ErrCode = esNotFound then
    ActiveFProc (ActiveBuff^, false, 0, false)
else
    Application.MessageBox (StrToPChar  ('Erro na Busca: ' +
               ErrorMessage (ErrCode)), 'Ateno!', mb_Ok + mb_IconExclamation);
end;

procedure TRODBRead.edt_buscaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = vk_Return then
    btn_BuscaClick (Sender);
end;

procedure TRODBRead.edt_buscaChange(Sender: TObject);
begin
edt_busca.ShowHint := Length (edt_busca.Text) > 0;
btn_busca.ShowHint := edt_busca.ShowHint;
end;

procedure TRODBRead.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if BancoAberto then
    mmn_closedbclick (Sender);
end;

end.
