unit U_ordem;

interface

uses
    rdonly;

type
    Str60 = string [60];
    Str120 = string [120];
    ChArr10 = array [1..10] of char;

function StringCompare (var Key1, Key2): CompareResult;

function LongintCompare (var Key1, Key2): CompareResult;

function ChArr10Compare (var Key1, Key2): CompareResult;

function RealCompare (var Key1, Key2): CompareResult;

function LongMin (A, B: longint): longint;

function LongMax (A, B: longint): longint;

implementation

uses
    Sysutils;

{$F+} { Isto  necessrio }

{ Funoes de Comparao a serem usadas com os diversos ndices do banco. }

function StringCompare (var Key1, Key2): CompareResult;
{        ---------------------------------------------

Ordem Alfabtica normal para string.
}
begin
if string (Key1) < string (Key2) then
    Result := -1
else
if string (Key1) = string (Key2) then
    Result := 0
else
    Result := +1;
end; { StringCompare }

function LongintCompare (var Key1, Key2): CompareResult;
{        ----------------------------------------------
Ordem crescente de longints
}
begin
if longint (Key1) < longint (Key2) then
    Result := -1
else
if longint (Key1) = longint (Key2) then
    Result := 0
else
    Result := +1;
end; { LongintCompare }

function ChArr10Compare (var Key1, Key2): CompareResult;
{        ----------------------------------------------
Ordem crescente de arrays de 10 caracteres
}
var
    I: word;
    Done: boolean;
begin
I := 1;
Done := false;
while not Done do
    if ChArr10 (Key1) [I] <> ChArr10 (Key2) [I] then
        Done := true
    else
    if I < 10 then
        Inc (I)
    else
        Done := true;
if ChArr10 (Key1) [I] < ChArr10 (Key2) [I] then
    Result := -1
else
if ChArr10 (Key1) [I] = ChArr10 (Key2) [I] then
    Result := 0
else
    Result := +1;
end; { ChArr10Compare }

function RealCompare (var Key1, Key2): CompareResult;
{        -------------------------------------------
Ordem decrescente de reais
}
begin
if real (Key1) > real (Key2) then
    Result := -1
else
if real (Key1) = real (Key2) then
    Result := 0
else
    Result := +1;
end; { RealCompare }

{$F-}

function LongMin (A, B: longint): longint;
{        --------------------------------
Mnimo entre dois inteiros, A e B
}
begin
if A < B then
    Result := A
else
    Result := B;
end; { LongMin }

function LongMax (A, B: longint): longint;
{        --------------------------------
Mximo entre dois inteiros, A e B
}
begin
if A > B then
    Result := A
else
    Result := B;
end; { LongMax }

end.
